<!-- This is a comment in md (Markdown) format, it will not be visible to the end user -->
## _Deprecation Notice_
This Pre-Built has been deprecated as of 01-15-2024 and will be end of life on 01-15-2025. The capabilities of this Pre-Built have been replaced by the [IAP - Data Manipulation](https://gitlab.com/itentialopensource/pre-built-automations/iap-data-manipulation)

# Remove Duplicates from Array of Numbers/Strings

## Table of Contents

*  [Overview](#overview)
*  [Installation Prerequisites](#installation-prerequisites)
*  [How to Install](#how-to-install)
*  [How to Run](#how-to-run)
*  [Attributes](#attributes)
*  [Examples](#examples)
*  [Additional Information](#additional-information)

## Overview

This JST allows IAP users to remove duplicates from an array of numbers or an array of strings. The JST uses the standard built in JavaScript object [Set](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Set) to remove duplicates. The resulting array will preserve only the first occurrences of each element from the original array.
For performance purposes, please note that the worst-case time complexity for this JST is $`O(n)`$.

## Installation Prerequisites
Users must satisfy the following prerequisites:
* Itential Automation Platform: `^2022.1`

## How to Install

To install the pre-built:
* Verify you are running a supported version of the Itential Automation Platform (IAP) as listed above in the [Prerequisites](#installation-prerequisites) section.
* The pre-build can be installed from within `App-Admin_Essential`. Simply search for the name of your desired pre-build and click the install button.

## How to Run

Use the following to run the pre-build:
1. Once the JST is installed as outlined in the [How to Install](#how-to-install) section above, navigate to the workflow where you would like to remove duplicates from an array and add a `JSON Transformation` task.

2. Inside the `Transformation` task, search for and select `removeDuplicates-NonObjects` (the name of the internal JST).

3. The inputs to the JST would be the array from which the duplicates have to be removed.

4. Save your input and the task is ready to run inside of IAP.

## Attributes  

Attributes for the pre-build are outlined in the following tables.

**Input**
<table border='1' style='border-collapse:collapse'>
<thead>
<tr>
<th>Attribute</th>
<th>Description</th>
<th>Type</th>
</tr>
</thead>
<tbody>
<tr>
<td><code>array</code></td>
<td>an array of numbers or an array of strings (array of booleans or nulls also supported)</td>
<td><code>array[numbers/integers/strings/booleans/nulls]</code></td>
</tr>
</tbody>
</table>


**Output**
<table border='1' style='border-collapse:collapse'>
<thead>
<tr>
<th>Attribute</th>
<th>Description</th>
<th>Type</th>
</tr>
</thead>
<tbody>
<tr>
<td><code>uniqueArray</code></td>
<td>array without duplicate elements</td>
<td><code>array[numbers/integers/strings/booleans/nulls]</code></td>
</tr>
</tbody>
</table>

## Examples

### Example 1
***Input Array***
```
[
    9,
    8,
    7.45,
    77,
    7,
    7,
    8,
    9
]
  ```

***Output Array***
```
[
  9,
  8,
  7.45,
  77,
  7
]
  ```
  
### Example 2
***Input Array***
```
[
    "hello",
    "world",
    "hello",
    null,
    true,
    true,
    null,
    "world",
    "HeLLo"
 ]
  ```

  ***Output Array***
```
[
  "hello",
  "world",
  null,
  true,
  "HeLLo"
]
  ```
  
## Additional Information
Please use your Itential Customer Succcess account if you need support when using this Pre-Built Transformation.
